<script setup>
import { FormKitSchema } from "@formkit/vue";
import { ref, computed, inject } from "vue";
import { useI18n } from 'vue-i18n'

const { t } = useI18n() // use as global scope
const current = ref('en')
const config = inject(Symbol.for('FormKitConfig'))

const changeLocale = () => {
  current.value = current.value === 'en' ? 'fr' : 'en'
  config.locale = current.value
}

const schema = [
  {
    $formkit: "text",
    name: "name",
    label: t('name'),
    placeholder: "Enter your name..."
  },
  {
    $formkit: "text",
    name: "surname",
    label: "Surname",
    placeholder: "Enter your surname..."
  },
  {
    $formkit: "date",
    name: "dob",
    label: "dob",
    value: "2023-07-04",
  },
  {
    $formkit: "tel",
    name: "phone",
    label: "Phone number",
    placeholder: "xxx-xxx-xxxx",
    validation: "required|matches:/^[0-9]{3}-[0-9]{3}-[0-9]{4}$/",
    validationVisibility: 'dirty',
    validationMessages: {
      matches: 'Sorry, your phone number doesn\'t match our requirement.'
    }
  },
  {
    $formkit: "checkbox",
    name: "hasEmail",
    label: "Has Email?",
  },
  {
    $el: "p",
    children: ["Email enabled? ", "$hasEmail"],
  },
  {
    $formkit: "email",
    name: "email",
    label: "Email",
    if: "$hasEmail",
    validation: "required|email",
  }
];

const data = ref({
  name: null,
  surname: null,
  dob: null,
  email: null,
  phone: null,
  hasEmail: false,
});

const handleSubmit = () => alert("Valid submit!");
</script>

<template>
  <a @click.prevent="changeLocale" href="#">
    <span v-if="current === 'en'">🇫🇷</span>
    <span v-if="current === 'fr'">🇺🇸</span>
  </a>
  <FormKit type="form" v-model="data" @submit="handleSubmit" form-class="outer-container">
    <FormKitSchema :schema="schema" :data="data" />
  </FormKit>
  <pre>{{ data }}</pre>
</template>

<style>
.outer-container {
  width: 400px;
  border: 1px solid #e4e4e4;
  padding: 1.5em;
  border-radius: 1em;
  margin: 0 auto 1em auto;
}

.input-group {
  display: flex;
  gap: 1em;
}

h1,
h3 {
  text-align: center;
}
</style>